/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ELEMENTS_OPTIONS_H
#define _ELEMENTS_OPTIONS_H

#include <compiz-common.h>

COMPIZ_BEGIN_DECLS

CompPluginVTable * getCompPluginInfo (void);

typedef enum
{
    ElementsDisplayOptionAbi,
    ElementsDisplayOptionIndex,
    ElementsDisplayOptionNextElementKey,
    ElementsDisplayOptionPrevElementKey,
    ElementsDisplayOptionToggleSelectedKey,
    ElementsDisplayOptionNum
} ElementsDisplayOptions;

typedef void (*elementsDisplayOptionChangeNotifyProc) (CompDisplay *display, CompOption *opt, ElementsDisplayOptions num);

CompOption *elementsGetDisplayOption (CompDisplay *d, ElementsDisplayOptions num);

typedef enum
{
    ElementsScreenOptionUpdateDelay,
    ElementsScreenOptionScreenDepth,
    ElementsScreenOptionScreenBoxing,
    ElementsScreenOptionOverWindows,
    ElementsScreenOptionElementType,
    ElementsScreenOptionElementIter,
    ElementsScreenOptionElementImage,
    ElementsScreenOptionElementCap,
    ElementsScreenOptionElementSize,
    ElementsScreenOptionElementSpeed,
    ElementsScreenOptionElementRotate,
    ElementsScreenOptionSnowSway,
    ElementsScreenOptionWindDirection,
    ElementsScreenOptionAutumnSway,
    ElementsScreenOptionAutumnYSway,
    ElementsScreenOptionViscosity,
    ElementsScreenOptionStarOffsetX,
    ElementsScreenOptionStarOffsetY,
    ElementsScreenOptionTitleFontColor,
    ElementsScreenOptionTitleFontSize,
    ElementsScreenOptionTitleBoldFont,
    ElementsScreenOptionTitleBackColor,
    ElementsScreenOptionTitleDisplayTime,
    ElementsScreenOptionTitleOnToggle,
    ElementsScreenOptionNum
} ElementsScreenOptions;

typedef void (*elementsScreenOptionChangeNotifyProc) (CompScreen *screen, CompOption *opt, ElementsScreenOptions num);

CompOption *elementsGetScreenOption (CompScreen *s, ElementsScreenOptions num);

typedef enum
{
    WindDirectionNone = 0,
    WindDirectionUp = 1,
    WindDirectionLeft = 2,
    WindDirectionRight = 3,
} ElementsWindDirectionEnum;

int              elementsGetAbi (CompDisplay *d);
CompOption *     elementsGetAbiOption (CompDisplay *d);
void             elementsSetAbiNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetIndex (CompDisplay *d);
CompOption *     elementsGetIndexOption (CompDisplay *d);
void             elementsSetIndexNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetNextElementKey (CompDisplay *d);
void             elementsSetNextElementKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetNextElementKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetNextElementKeyOption (CompDisplay *d);
void             elementsSetNextElementKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetPrevElementKey (CompDisplay *d);
void             elementsSetPrevElementKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetPrevElementKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetPrevElementKeyOption (CompDisplay *d);
void             elementsSetPrevElementKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

CompAction *     elementsGetToggleSelectedKey (CompDisplay *d);
void             elementsSetToggleSelectedKeyInitiate (CompDisplay *d, CompActionCallBackProc init);
void             elementsSetToggleSelectedKeyTerminate (CompDisplay *d, CompActionCallBackProc term);
CompOption *     elementsGetToggleSelectedKeyOption (CompDisplay *d);
void             elementsSetToggleSelectedKeyNotify (CompDisplay *d, elementsDisplayOptionChangeNotifyProc notify);

int              elementsGetUpdateDelay (CompScreen *s);
CompOption *     elementsGetUpdateDelayOption (CompScreen *s);
void             elementsSetUpdateDelayNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetScreenDepth (CompScreen *s);
CompOption *     elementsGetScreenDepthOption (CompScreen *s);
void             elementsSetScreenDepthNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetScreenBoxing (CompScreen *s);
CompOption *     elementsGetScreenBoxingOption (CompScreen *s);
void             elementsSetScreenBoxingNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

Bool             elementsGetOverWindows (CompScreen *s);
CompOption *     elementsGetOverWindowsOption (CompScreen *s);
void             elementsSetOverWindowsNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementType (CompScreen *s);
CompOption *     elementsGetElementTypeOption (CompScreen *s);
void             elementsSetElementTypeNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementIter (CompScreen *s);
CompOption *     elementsGetElementIterOption (CompScreen *s);
void             elementsSetElementIterNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementImage (CompScreen *s);
CompOption *     elementsGetElementImageOption (CompScreen *s);
void             elementsSetElementImageNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementCap (CompScreen *s);
CompOption *     elementsGetElementCapOption (CompScreen *s);
void             elementsSetElementCapNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementSize (CompScreen *s);
CompOption *     elementsGetElementSizeOption (CompScreen *s);
void             elementsSetElementSizeNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementSpeed (CompScreen *s);
CompOption *     elementsGetElementSpeedOption (CompScreen *s);
void             elementsSetElementSpeedNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

CompListValue *  elementsGetElementRotate (CompScreen *s);
CompOption *     elementsGetElementRotateOption (CompScreen *s);
void             elementsSetElementRotateNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetSnowSway (CompScreen *s);
CompOption *     elementsGetSnowSwayOption (CompScreen *s);
void             elementsSetSnowSwayNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetWindDirection (CompScreen *s);
CompOption *     elementsGetWindDirectionOption (CompScreen *s);
void             elementsSetWindDirectionNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

float            elementsGetAutumnSway (CompScreen *s);
CompOption *     elementsGetAutumnSwayOption (CompScreen *s);
void             elementsSetAutumnSwayNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetAutumnYSway (CompScreen *s);
CompOption *     elementsGetAutumnYSwayOption (CompScreen *s);
void             elementsSetAutumnYSwayNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

float            elementsGetViscosity (CompScreen *s);
CompOption *     elementsGetViscosityOption (CompScreen *s);
void             elementsSetViscosityNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetStarOffsetX (CompScreen *s);
CompOption *     elementsGetStarOffsetXOption (CompScreen *s);
void             elementsSetStarOffsetXNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetStarOffsetY (CompScreen *s);
CompOption *     elementsGetStarOffsetYOption (CompScreen *s);
void             elementsSetStarOffsetYNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

unsigned short * elementsGetTitleFontColor (CompScreen *s);
unsigned short   elementsGetTitleFontColorRed (CompScreen *s);
unsigned short   elementsGetTitleFontColorGreen (CompScreen *s);
unsigned short   elementsGetTitleFontColorBlue (CompScreen *s);
unsigned short   elementsGetTitleFontColorAlpha (CompScreen *s);
CompOption *     elementsGetTitleFontColorOption (CompScreen *s);
void             elementsSetTitleFontColorNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetTitleFontSize (CompScreen *s);
CompOption *     elementsGetTitleFontSizeOption (CompScreen *s);
void             elementsSetTitleFontSizeNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

Bool             elementsGetTitleBoldFont (CompScreen *s);
CompOption *     elementsGetTitleBoldFontOption (CompScreen *s);
void             elementsSetTitleBoldFontNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

unsigned short * elementsGetTitleBackColor (CompScreen *s);
unsigned short   elementsGetTitleBackColorRed (CompScreen *s);
unsigned short   elementsGetTitleBackColorGreen (CompScreen *s);
unsigned short   elementsGetTitleBackColorBlue (CompScreen *s);
unsigned short   elementsGetTitleBackColorAlpha (CompScreen *s);
CompOption *     elementsGetTitleBackColorOption (CompScreen *s);
void             elementsSetTitleBackColorNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

int              elementsGetTitleDisplayTime (CompScreen *s);
CompOption *     elementsGetTitleDisplayTimeOption (CompScreen *s);
void             elementsSetTitleDisplayTimeNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

Bool             elementsGetTitleOnToggle (CompScreen *s);
CompOption *     elementsGetTitleOnToggleOption (CompScreen *s);
void             elementsSetTitleOnToggleNotify (CompScreen *s, elementsScreenOptionChangeNotifyProc notify);

#ifndef GENERIC_PRIVATE_DEFINES
#define GENERIC_PRIVATE_DEFINES

#define GET_PLUGIN_CORE(object, plugin) \
    ((plugin##Core *) (object)->base.privates[plugin##CorePrivateIndex].ptr)
#define PLUGIN_CORE(object, plugin, prefix) \
    plugin##Core * prefix##c = GET_PLUGIN_CORE (object, plugin)

#define GET_PLUGIN_DISPLAY(object, plugin) \
    ((plugin##Display *) \
	(object)->base.privates[plugin##DisplayPrivateIndex].ptr)
#define PLUGIN_DISPLAY(object, plugin, prefix) \
    plugin##Display * prefix##d = GET_PLUGIN_DISPLAY (object, plugin)

#define GET_PLUGIN_SCREEN(object, parent, plugin) \
    ((plugin##Screen *) \
	(object)->base.privates[(parent)->screenPrivateIndex].ptr)
#define PLUGIN_SCREEN(object, plugin, prefix) \
    plugin##Screen * prefix##s = \
	GET_PLUGIN_SCREEN (object, \
	GET_PLUGIN_DISPLAY ((object)->display, plugin), plugin)

#define GET_PLUGIN_WINDOW(object, parent, plugin) \
    ((plugin##Window *) \
	(object)->base.privates[(parent)->windowPrivateIndex].ptr)
#define PLUGIN_WINDOW(object, plugin, prefix) \
    plugin##Window * prefix##w = \
	GET_PLUGIN_WINDOW  (object, \
	GET_PLUGIN_SCREEN  ((object)->screen, \
	GET_PLUGIN_DISPLAY ((object)->screen->display, plugin), plugin), plugin)

#endif

COMPIZ_END_DECLS

#endif
